#pragma once

#ifndef MONWIDGETGL_HPP
#define MONWIDGETGL_HPP

#include <GL/glew.h>
#include <GL/gl.h>

#include <QtOpenGL/QGLWidget>
#include <QMouseEvent>

#include "../libinterface/navigator_tool.hpp"
#include "../libmesh/mesh.hpp"
#include "../libopengl/mesh_opengl.hpp"
#include "scene.hpp"


class monWidgetGL : public QGLWidget
{
    Q_OBJECT
public:
    monWidgetGL(const QGLFormat& format,QGLWidget *parent = 0);
    ~monWidgetGL();


    void afficher();
    void wireframe(bool est_actif);

    scene scene_3d;

protected:

    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);

    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);
    void timerEvent(QTimerEvent *event);



private:

    void setup_camera();

    cpe::navigator_tool nav;

    bool etat_affichage;

};

#endif
