
/** TP 4ETI - CPE Lyon - 2013/2014 */

#include <GL/glew.h>

#include "scene.hpp"
#include "glutils.hpp"

#include "../lib3d/matrix2.hpp"

#include "../libperlin/perlin.hpp"
#include "../external/muparser/include/muParser.h"



#include <cmath>


using namespace cpe;

GLuint scene::get_current_shader_id() const
{
    return shader_program_id;
}

void scene::load_scene()
{

    shader_program_id = read_shader("local/shader.vert", "local/shader.frag");PRINT_OPENGL_ERROR();

    surf.resize(50,50);
    surf.compute_normal();
    surf.fill_color_xyz();
    surf_opengl.fill_vbo(surf);


}



void scene::draw_scene()
{
    PRINT_OPENGL_ERROR();
    surf_opengl.draw();PRINT_OPENGL_ERROR();


}





scene::scene()
    :shader_program_id(0)
{

}

void scene::build_surface(const std::string& formula_x,
                          const std::string& formula_y,
                          const std::string& formula_z,
                          float u_min,float u_max,
                          float v_min,float v_max,
                          int Nu,int Nv,bool inverse_orientation)
{
    surf.resize(Nu,Nv);


    u_min_save=u_min;u_max_save=u_max;
    v_min_save=v_min;v_max_save=v_max;

    double u=0.0,v=0.0;
    mu::Parser parser[3];
    for(int k=0;k<3;++k)
    {
        parser[k].DefineVar("u",&u);
        parser[k].DefineVar("v",&v);
    }

    parser[0].SetExpr(formula_x);
    parser[1].SetExpr(formula_y);
    parser[2].SetExpr(formula_z);

    for(int ku=0;ku<Nu;++ku)
    {
        const float u_local=ku/static_cast<float>(Nu-1);
        u=u_min+(u_max-u_min)*u_local;
        for(int kv=0;kv<Nv;++kv)
        {
            const float v_local=kv/static_cast<float>(Nv-1);
            v=v_min+(v_max-v_min)*v_local;


            vec3 p(parser[0].Eval(),parser[1].Eval(),parser[2].Eval());

            surf(ku,kv)=p;
        }
    }

    if(inverse_orientation==true)
        surf.inverse_orientation();
    surf.compute_normal();
    surf.fill_color_normal();

    surf_opengl.fill_vbo(surf);
}



