
/** TP 4ETI - CPE Lyon - 2013/2014 */

#pragma once

#ifndef SCENE_HPP
#define SCENE_HPP

#include <GL/gl.h>
#include <GL/glew.h>

#include "../lib3d/matrix3.hpp"
#include "../lib3d/vec3.hpp"
#include "../libmesh/mesh.hpp"
#include "../libmesh/parametric_surface.hpp"
#include "../libopengl/mesh_opengl.hpp"

#include <vector>
#include <string>




class scene
{
public:

    scene();



    /** \brief Method called only once at the beginning (load off files ...) */
    void load_scene();

    /** \brief Method called at every frame */
    void draw_scene();

    void build_surface(const std::string& formula_x,
                       const std::string& formula_y,
                       const std::string& formula_z,
                       float u_min,float u_max,
                       float v_min,float v_max,
                       int Nu,int Nv,bool inverse_orientation);



    GLuint get_current_shader_id() const;


private:

    cpe::parametric_surface surf;
    cpe::mesh_opengl surf_opengl;

    float u_min_save,u_max_save;
    float v_min_save,v_max_save;


    GLuint shader_program_id;


};

#endif
