#version 120

varying vec4 position_3d_original;
varying vec4 position_3d_modelview;
varying vec3 normal;
varying vec4 color;

uniform vec3 light=vec3(0.5f,0.3f,5.0f);

//Un Fragment Shader minimaliste
void main (void)
{
    vec3 n=normalize(normal);

    vec3 p=position_3d_modelview.xyz;
    vec3 vertex_to_light=normalize(light-p);
    vec3 reflected_light=reflect(-vertex_to_light,n);
    vec3 user_to_vertex=normalize(-p);

    float diffuse_term=0.7f*clamp(dot(n,vertex_to_light),0.0f,1.0f);
    float specular_term=0.2f*pow(clamp(dot(reflected_light,user_to_vertex),0.0f,1.0f),128.0f);
    float ambiant_term=0.2f;

    vec4 white=vec4(1.0f,1.0f,1.0f,0.0f);

    gl_FragColor = (ambiant_term+diffuse_term)*color+specular_term*white;

    //couleur du fragment
    //gl_FragColor = vec4(normal,1.0f);
}
